clear, clc
close all

%% define cloning region in source image

screen_size = get(0,'ScreenSize');
L = screen_size(3);
H = screen_size(4);

% display source image g
g = imread('source.jpg');
[h_g, w_g, ~] = size(g);
figure('Name','source image','Position',[0,0,0.33*L,0.5*H])
imagesc(g)
axis equal
axis off
hold on

% select rectangle R in source image
disp('Select a rectangle by clicking on top left and bottom right corner')
[x_R, y_R] = ginput(2);

x_R = min(max(round(x_R),1),w_g);
y_R = min(max(round(y_R),1),h_g);
x_R_min = min(x_R(:));
x_R_max = max(x_R(:));
y_R_min = min(y_R(:));
y_R_max = max(y_R(:));

line([x_R_min x_R_max],[y_R_min y_R_min],'Color','r','LineWidth',2)
line([x_R_min x_R_max],[y_R_max y_R_max],'Color','r','LineWidth',2)
line([x_R_min x_R_min],[y_R_min y_R_max],'Color','r','LineWidth',2)
line([x_R_max x_R_max],[y_R_min y_R_max],'Color','r','LineWidth',2)

% initialize image with source image
g0 = g(y_R_min:y_R_max,x_R_min:x_R_max,:);


%% define editing region in target image

% display target image f
f = imread('target.jpg');
[h_f, w_f, ~] = size(f);
figure('Name','target image','Position',[0.33*L,0,0.67*L,H])
imagesc(f)
axis equal
axis off

% select rectangular editing region in target image
disp('Select top-left and bottom-right corner of editing region Omega_0 in target image')
[x_0, y_0] = ginput(2);

x_0 = min(max(round(x_0),1),w_f);
y_0 = min(max(round(y_0),1),h_f);
x_0_min = min(x_0(:));
x_0_max = max(x_0(:));
y_0_min = min(y_0(:));
y_0_max = max(y_0(:));

line([x_0_min x_0_max],[y_0_min y_0_min],'Color','r','LineWidth',2)
line([x_0_min x_0_max],[y_0_max y_0_max],'Color','r','LineWidth',2)
line([x_0_min x_0_min],[y_0_min y_0_max],'Color','r','LineWidth',2)
line([x_0_max x_0_max],[y_0_min y_0_max],'Color','r','LineWidth',2)

f0 = f(y_0_min:y_0_max,x_0_min:x_0_max,:);
[h0, w0, channels] = size(f0);

% resize u to match dimensions of editing region
g0 = imresize(g0,[h0 w0]);

%% compute and display initial version of final image
% (editing region in f replaced by g0)

u_tot = f;
u_tot(y_0_min:y_0_max,x_0_min:x_0_max,:) = g0;

% display
figure('Name','preliminary cloning result','Position',[0,0,L,H])
imagesc(u_tot)
axis equal
axis off

%% save results to file

save poisson_editing_setup